var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, EventEmitter, Output } from '@angular/core';
import { DefaultEditor } from './default-editor';
var InputEditorComponent = (function (_super) {
    __extends(InputEditorComponent, _super);
    function InputEditorComponent() {
        var _this = _super.call(this) || this;
        _this.onChange = new EventEmitter();
        return _this;
    }
    InputEditorComponent.prototype.ngAfterContentInit = function () {
        this.formatFunction = this.cell.getColumn().getInputFormatFunction();
        if (this.formatFunction) {
            this.cell.setValue(this.formatFunction(this.cell.getValue()));
        }
    };
    InputEditorComponent.prototype.onKeyup = function (event) {
        if (this.formatFunction) {
            this.cell.setValue(this.formatFunction(event.currentTarget.value));
        }
    };
    return InputEditorComponent;
}(DefaultEditor));
__decorate([
    Output(),
    __metadata("design:type", Object)
], InputEditorComponent.prototype, "onChange", void 0);
InputEditorComponent = __decorate([
    Component({
        selector: 'input-editor',
        styles: [":host input,:host textarea{width:100%;line-height:normal;padding:.375em .75em} /*# sourceMappingURL=editor.component.css.map */ "],
        template: "\n    <input *ngIf=\"cell.isEditable()\" [ngClass]=\"inputClass\"\n           class=\"form-control\"\n           [(ngModel)]=\"cell.newValue\"\n           [name]=\"cell.getId()\"\n           [placeholder]=\"cell.getTitle()\"\n           [disabled]=\"!cell.isEditable()\"\n           (click)=\"onClick.emit($event)\"\n           (keydown.enter)=\"onEdited.emit($event)\"\n           (keydown.esc)=\"onStopEditing.emit()\"\n           (change)=\"onChange.emit($event)\"\n           (keyup)=\"onKeyup($event)\">\n    <!-- just use regular view logic when cell is not editable-->\n    <div *ngIf=\"!cell.isEditable()\" [ngSwitch]=\"cell.getColumn().type\">\n      <custom-view-component *ngSwitchCase=\"'custom'\" [cell]=\"cell\"></custom-view-component>\n      <div *ngSwitchCase=\"'html'\" [innerHTML]=\"cell.getValue()\"></div>\n      <div *ngSwitchDefault>{{ cell.getValue() }}</div>\n    </div>\n  ",
    }),
    __metadata("design:paramtypes", [])
], InputEditorComponent);
export { InputEditorComponent };
//# sourceMappingURL=input-editor.component.js.map