var Cell = (function () {
    function Cell(value, row, column, dataSet, isNew) {
        this.value = value;
        this.row = row;
        this.column = column;
        this.dataSet = dataSet;
        this.isNew = isNew;
        this.newValue = '';
        this.customObject = null;
        this.newValue = value;
    }
    Cell.prototype.getColumn = function () {
        return this.column;
    };
    Cell.prototype.getRow = function () {
        return this.row;
    };
    Cell.prototype.getValue = function () {
        var valid = this.column.getValuePrepareFunction() instanceof Function;
        var prepare = valid ? this.column.getValuePrepareFunction() : Cell.PREPARE;
        return prepare.call(null, this.value, this.row.getData());
    };
    Cell.prototype.setValue = function (value) {
        this.newValue = value;
    };
    Cell.prototype.getId = function () {
        return this.getColumn().id;
    };
    Cell.prototype.getTitle = function () {
        return this.getColumn().title;
    };
    Cell.prototype.isEditable = function () {
        if (this.getRow().index === -1) {
            return this.getColumn().isAddable;
        }
        else {
            var valid = this.column.getIsEditableFunction() instanceof Function;
            var isEditableFunc = valid ? this.column.getIsEditableFunction() : Cell.EDITABLE;
            return isEditableFunc(this);
        }
    };
    Cell.prototype.setCustomObject = function (obj) {
        this.customObject = obj;
    };
    Cell.prototype.getCustomObject = function () {
        return this.customObject;
    };
    return Cell;
}());
export { Cell };
Cell.PREPARE = function (value) { return value; };
Cell.EDITABLE = function (cell) { return cell.getColumn().isEditable; };
//# sourceMappingURL=cell.js.map